=== debian/changelog ===
mathgl (2.3.3-3build1) xenial; urgency=medium

  * No-change rebuild for giflib soname change.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 23 Oct 2015 10:09:59 +0000

mathgl (2.3.3-3) unstable; urgency=medium

  * Disable need for C++11 support (Closes: #800460)

 -- Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>  Mon, 05 Oct 2015 21:53:19 +0300

mathgl (2.3.3-2) unstable; urgency=medium

  * Fix FTBFS on several arches (patched by  E. G. Evans) (#Closes: 797610)
  * Set enable-qt ON in json sample enable line

 -- Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>  Sat, 05 Sep 2015 22:51:26 +0300

mathgl (2.3.3-1) unstable; urgency=medium

  * Imported Upstream version 2.3.3 (Closes: #788776)
  * Transition from Qt4 to Qt5 (Closes: #784495)
  * Add libqt5opengl5-dev, libxcursor-dev and fluid to Build-Depends
  * Set compat=9
  * Fix several dep5 related issues in d/copyright

 -- Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>  Sat, 29 Aug 2015 03:52:28 +0300

mathgl (2.3.2-1) experimental; urgency=medium

  * Imported Upstream version 2.3.2
  * Fix d/copyright format as prompted by lintian warning
  * Add file argument to udav exec in udav/udav.desktop
  * Fix d/copyright as prompted by lintian info
  * Replace swig3.0 build dep by swig
  * Update Conflicts/Replaces entries in d/control
  * Set versioned build dependency for libssl1.0.0 to avert FTBFS
  * Update copyright holder names in d/copyright

 -- Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>  Thu, 12 Feb 2015 11:26:30 +0200
